#include "testlib.h"
#include <bits/stdc++.h>
#include <stdlib.h>
#include <stdio.h>

using namespace std;

const long long MAX = 1e18;

void checkNumber(long long t) {
    if (t < 1 || t > MAX)
        quitf(_pe, "Number %lld must be from 1 to %lld", t, MAX);
}

long long gcd(long long a, long long b) {
    if (b != 0)
        return gcd(b, a % b);
    return a;
}

pair<long long, long long> f(long long n, long long x) {
    long long a = n / x;
    long long b = n;
    long long d = gcd(a, b);
    return make_pair(a / d, b / d);
}

const int MAX_STEPS = 1000;

int main(int argc, char* argv[]) {
    registerInteraction(argc, argv);

    int g = inf.readInt();
    int q = inf.readInt();
    cout << g << endl;

    int maxSteps = 0;
    for (int i = 0; i < g; ++i) {
        int steps = 0;
        long long n = inf.readLong();
        bool isOn = true;
        while(isOn) {
            char s = ouf.readChar();
            if (s == 'X') {
                long long t = ouf.readLong();
                tout << "< X " << t << endl;
                checkNumber(t);
                pair<long long, long long> ans = f(n, t);
                steps++;
                if (steps > q) {
                    cout << -1 << endl;
                    tout << "> -1" << endl;
                    quitf(_wa, "Query limit exceeded");
                }
                cout << ans.first << " " << ans.second << endl;
                tout << "> " << ans.first << " " << ans.second << endl;
            } else if (s == 'N') {
                long long t = ouf.readLong();
                tout << "< N " << t << endl;
                checkNumber(t);
                if (n != t) {
                    cout << "Wrong" << endl;
                    tout << "> Wrong" << endl;
                    quitf(_wa, "Answer: N=%lld; Program: N=%lld", n, t);
                }
                cout << "Correct" << endl;
                tout << "> Correct" << endl;

                isOn = false;
            } else {
                quitf(_pe, "Illegal query %c", s);
            }
            ouf.readLine();
        }
        maxSteps = max(maxSteps, steps);
    }
    tout << "Ok, maximum is " << maxSteps << " queries" << endl;
    quitf(_ok, "Ok, maximum is %d queries", maxSteps);
}
